<template>
  <div class="carousel">
    <hooper
      ref="carousel"
      :vertical="vertical"
      :items-to-show="itemsToShow"
      :items-to-slide="itemsToSlide"
      :infinite-scroll="infiniteScroll"
      :wheel-control="wheelControl"
      @slide="onSlide">
      <slide
        v-for="(entity, i) in entities"
        :key="i">
        <slot
          :entity="entity"
          :index="i"
          name="entity"/>
      </slide>

      <hooper-pagination
        v-if="hasPagination"
        slot="hooper-addons"
        mode="fraction"/>
    </hooper>
    <div class="carousel-navigations">
      <button
        type="button"
        class="carousel-navigations-control _prev"
        :class="controlsClass"
        :disabled="currentSlide === 0"
        @click.prevent="slidePrev">
        <slot name="prev"/>
      </button>
      <button
        type="button"
        class="carousel-navigations-control _next"
        :class="controlsClass"
        :disabled="currentSlide === entities.length - 1"
        @click.prevent="slideNext">
        <slot name="next"/>
      </button>
    </div>
  </div>
</template>

<script>
// https://baianat.github.io/hooper/
// @TODO: когда переключаем мышкой срабатывает клик https://github.com/baianat/hooper/issues/127
import { Hooper, Slide, Pagination as HooperPagination } from 'hooper';

export default {
  name: 'Carousel',
  components: {
    Hooper,
    Slide,
    HooperPagination,
  },
  props: {
    entities: {
      type: Array,
      default() { return []; },
    },
    itemsToShow: {
      type: Number,
      default: 1,
    },
    itemsToSlide: {
      type: Number,
      default: 1,
    },
    vertical: {
      type: Boolean,
      default: false,
    },
    hasPagination: {
      type: Boolean,
      default: false,
    },
    infiniteScroll: {
      type: Boolean,
      default: false,
    },
    controlsClass: {
      type: String,
      default: '',
    },
    hasLightBox: {
      type: Boolean,
      default: true,
    },
    wheelControl: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      slidesCount: 0,
      currentSlide: 0,
    };
  },
  methods: {

    onSlide(state) {
      this.$emit('slide', state);
      this.currentSlide = state.currentSlide;
    },
    slidePrev() {
      this.$refs.carousel.slidePrev();
    },
    slideNext() {
      this.$refs.carousel.slideNext();
    },
  },
};
</script>

<style lang="postcss">
  .carousel {
    position: relative;

    &-navigations {
      &-control {
        position: absolute;
        display: inline-flex;
        align-items: center;
        justify-content: center;
        border: none;
        padding: 0;
        outline: none;

        &._double {
          width: 4rem;
          height: 5rem;
          background-color: transparent;
          background-image: none;
          &._prev,
          &._next {
            bottom: calc(50% - 2.5rem);
          }

          &._prev {
            & > .svg {
              transform: rotate(0deg);
            }
          }

          &._next {
            & > .svg {
              transform: rotate(-180deg);
            }
          }
        }

        &._circle {
          width: var(--btn-height-regular);
          height: var(--btn-height-regular);
          outline: none;
          border-radius: 50%;
          background-color: var(--bg-main);
          border:  1px solid var(--border-color-main);
          box-shadow: 0 2px 3px rgba(0, 0, 0, 0.2);

          &:hover {
            border-color: var(--border-color-hover);
            .svg {
              fill: var(--fill-hover);
            }
          }

          &:active, &:focus {
            border-color: var(--border-color-active);
            .svg {
              fill: var(--fill-active);
            }
          }
        }

        &._transparent {
          background-color: transparent;
          background-image: none;
        }

        &._prev,
        &._next {
          bottom: calc(50% - 1.1875rem);
          cursor: pointer;
          transition: opacity 0.4s var(--transition-easeOutQuad);

          &[disabled] {

          }
        }

        &._prev {
          left: -0.5625rem;

          & > svg {
            transform: rotate(90deg);
          }
        }

        &._next {
          right: -0.5625rem;

          & > svg {
            transform: rotate(-90deg);
          }
        }
      }
    }

    .hooper {
      position: relative;
      box-sizing: border-box;
      width: 100%;
      height: inherit;
      outline: none;

      &-list {
        overflow: hidden;
        width: 100%;
        height: 100%;
      }

      &-track {
        display: flex;
        box-sizing: border-box;
        width: 100%;
        height: 100%;
        padding: 0;
        margin: 0;
      }

      &-slide {
        display: flex;
        flex-shrink: 0;
        padding: 0;
        list-style: none;
        cursor: pointer;

        img {
          display: block;
          height: 100%;
          width: 100%;
          object-fit: contain;
        }
      }

      &-liveregion {
        display: none;
      }

      &.is-vertical .hooper-track {
        flex-direction: column;
        height: inherit;
      }
    }

    &._vertical {
      padding: 2rem 0;

      .carousel-navigations {
        &-control {
          width: 100%;
          height: 1rem;

          &._prev,
          &._next {
            .svg {
              width: auto;
              height: 1rem;
              stroke-width: 1.5;
              stroke: var(--border-color-main);
              transition: stroke 0.2s var(--transition-easeOutQuad);
            }
            &:hover {
              .svg {
                stroke: var(--color-main);
              }
            }
            &[disabled] {

            }
          }

          &._prev {
            top: 0;
            left: auto;

            & > .svg {
              transform: rotate(180deg);
            }
          }

          &._next {
            bottom: 0;
            right: auto;

            & > .svg {
              transform: rotate(0deg);
            }
          }
        }
      }

      .hooper-slide {
        cursor: pointer;

        &.is-current {
          img {
            filter: opacity(30%);
          }
        }
      }

      .hooper-pagination {
        position: absolute;
        top: 96%;
        left: calc(100% + 1.375rem);
        display: block;
        padding: 0.25rem 0.625rem;
        font-size: 0.75rem;
        white-space: nowrap;
        background-color: rgba(255,255,255,0.6);
        border-radius: 1rem;
      }
    }

    @media screen and (max-width: 980px) {
      .hooper-pagination {
        position: absolute;
        top: auto;
        bottom: 1rem;
        left: 1rem;
        display: block;
        padding: 0.25rem 0.625rem;
        font-size: 0.875rem;
        white-space: nowrap;
        background-color: rgba(255, 255, 255, 0.6);
        border-radius: 1rem;
      }
    }
  }
</style>
